load VAdata.mat
load Volumes.mat
% VAdata from gVOD database(https://doi.org/10.1594/PANGAEA.915758) 
%% calculate total viral abundance in open ocean
bin_zo_up=[0 10 20 30 40 50 60 70 80 90 100 200 500 1000 2000];
bin_zo_bottom=[10 20 30 40 50 60 70 80 90 100 200 500 1000 2000 15000];
VA_open_A=VA_open(VA_open(:,7)==1,:);
VA_open_An=VA_open_A(VA_open_A(:,2)>=0,:);
VA_open_As=VA_open_A(VA_open_A(:,2)<0,:);
VA_open_P=VA_open(VA_open(:,7)==2,:);
VA_open_Pn=VA_open_P(VA_open_P(:,2)>=0,:);
VA_open_Ps=VA_open_P(VA_open_P(:,2)<0,:);
VA_open_I=VA_open(VA_open(:,7)==3,:);
VA_open_Ar=VA_open(VA_open(:,7)==4,:);
VA_open_Mnb=VA_open(VA_open(:,7)==5,:);
% calculate mean and se of each bin in 7 basins.
for voi=1:15
    %Atlantic
    eval(['VA_A_s',num2str(voi),'=VA_open_As(VA_open_As(:,4)<=bin_zo_bottom(voi) & VA_open_As(:,4)>bin_zo_up(voi),:);'])
    eval(['VA_A_n',num2str(voi),'=VA_open_An(VA_open_An(:,4)<=bin_zo_bottom(voi) & VA_open_An(:,4)>bin_zo_up(voi),:);'])
    eval(['meanVA_As(voi)=mean(VA_A_s',num2str(voi),'(:,6));'])
    eval(['seVA_As(voi)=std(VA_A_s',num2str(voi),'(:,6))./sqrt(length(VA_A_s',num2str(voi),'(:,6)));'])
    eval(['meanVA_An(voi)=mean(VA_A_n',num2str(voi),'(:,6));'])
    eval(['seVA_An(voi)=std(VA_A_n',num2str(voi),'(:,6))./sqrt(length(VA_A_n',num2str(voi),'(:,6)));'])
    % Pacific
    eval(['VA_P_s',num2str(voi),'=VA_open_Ps(VA_open_Ps(:,4)<=bin_zo_bottom(voi) & VA_open_Ps(:,4)>bin_zo_up(voi),:);'])
    eval(['VA_P_n',num2str(voi),'=VA_open_Pn(VA_open_Pn(:,4)<=bin_zo_bottom(voi) & VA_open_Pn(:,4)>bin_zo_up(voi),:);'])
    eval(['meanVA_Ps(voi)=mean(VA_P_s',num2str(voi),'(:,6));'])
    eval(['seVA_Ps(voi)=std(VA_P_s',num2str(voi),'(:,6))./sqrt(length(VA_P_s',num2str(voi),'(:,6)));'])
    eval(['meanVA_Pn(voi)=mean(VA_P_n',num2str(voi),'(:,6));'])
    eval(['seVA_Pn(voi)=std(VA_P_n',num2str(voi),'(:,6))./sqrt(length(VA_P_n',num2str(voi),'(:,6)));'])
    % Indian
    eval(['VA_I_',num2str(voi),'=VA_open_I(VA_open_I(:,4)<=bin_zo_bottom(voi) & VA_open_I(:,4)>bin_zo_up(voi),:);'])
    eval(['meanVA_I(voi)=mean(VA_I_',num2str(voi),'(:,6));'])
    eval(['seVA_I(voi)=std(VA_I_',num2str(voi),'(:,6))./sqrt(length(VA_I_',num2str(voi),'(:,6)));'])
    % Mediterranean and Baltic
    eval(['VA_Mnb_',num2str(voi),'=VA_open_Mnb(VA_open_Mnb(:,4)<=bin_zo_bottom(voi) & VA_open_Mnb(:,4)>bin_zo_up(voi),:);'])
    eval(['meanVA_Mnb(voi)=mean(VA_Mnb_',num2str(voi),'(:,6));'])
    eval(['seVA_Mnb(voi)=std(VA_Mnb_',num2str(voi),'(:,6))./sqrt(length(VA_Mnb_',num2str(voi),'(:,6)));'])
    % Arctic
    eval(['VA_Ar_',num2str(voi),'=VA_open_Ar(VA_open_Ar(:,4)<=bin_zo_bottom(voi) & VA_open_Ar(:,4)>bin_zo_up(voi),:);'])
    eval(['meanVA_Ar(voi)=mean(VA_Ar_',num2str(voi),'(:,6));'])
    eval(['seVA_Ar(voi)=std(VA_Ar_',num2str(voi),'(:,6))./sqrt(length(VA_Ar_',num2str(voi),'(:,6)));'])
 % substituted by the value of North Atlantic
    if isnan(meanVA_Mnb(voi))==1
        meanVA_Mnb(voi)=meanVA_An(voi);
        seVA_Mnb(voi)=seVA_An(voi);
    end
    if isnan(meanVA_Ar(voi))==1
        meanVA_Ar(voi)=meanVA_An(voi);
        seVA_Ar(voi)=seVA_An(voi);
    end
end

Total_VAopen=sum(meanVA_As.*V_Atlantic_os*1e6+meanVA_An.*V_Atlantic_on*1e6+meanVA_Ps.*V_Pacific_os*1e6+meanVA_Pn.*V_Pacific_on*1e6+...
    meanVA_I.*V_Indian_o*1e6+meanVA_Ar.*V_Arctic_o*1e6+meanVA_Mnb.*V_Mnb_o*1e6);
total_SEopen=sum(seVA_As.*V_Atlantic_os*1e6+seVA_An.*V_Atlantic_on*1e6+seVA_Ps.*V_Pacific_os*1e6+...
    seVA_Pn.*V_Pacific_on*1e6+seVA_I.*V_Indian_o*1e6+seVA_Ar.*V_Arctic_o*1e6+seVA_Mnb.*V_Mnb_o*1e6);
%% % calculate total viral abundance in coastal area
bin_zc_up=[0 5 10 25 50 100]; % bins boundary
bin_zc_bottom=[5 10 25 50 100 200];
% divide to 7 basin
VA_coast1=VA_coast(VA_coast(:,8)<0,:);
VA_coast_A=VA_coast1(VA_coast1(:,7)==1,:);
VA_coast_An=VA_coast_A(VA_coast_A(:,2)>=0,:);
VA_coast_As=VA_coast_A(VA_coast_A(:,2)<0,:);
VA_coast_P=VA_coast1(VA_coast1(:,7)==2,:);
VA_coast_Pn=VA_coast_P(VA_coast_P(:,2)>=0,:);
VA_coast_Ps=VA_coast_P(VA_coast_P(:,2)<0,:);
VA_coast_I=VA_coast1(VA_coast1(:,7)==3,:);
VA_coast_Ar=VA_coast1(VA_coast1(:,7)==4,:);
VA_coast_Mnb=VA_coast1(VA_coast1(:,7)==5,:);
% calculate mean and se of each bin in 7 basins.
for voi=1:6
    % Atlantic
    eval(['VA_As_c',num2str(voi),'=VA_coast_As(VA_coast_As(:,4)<=bin_zc_bottom(voi) & VA_coast_As(:,4)>bin_zc_up(voi),:);'])
    eval(['meanVA_As_c(voi)=mean(VA_As_c',num2str(voi),'(:,6));'])
    eval(['seVA_As_c(voi)=std(VA_As_c',num2str(voi),'(:,6))./sqrt(length(VA_As_c',num2str(voi),'(:,6)));'])

    eval(['VA_An_c',num2str(voi),'=VA_coast_An(VA_coast_An(:,4)<=bin_zc_bottom(voi) & VA_coast_An(:,4)>bin_zc_up(voi),:);'])
    eval(['meanVA_An_c(voi)=mean(VA_An_c',num2str(voi),'(:,6));'])
    eval(['seVA_An_c(voi)=std(VA_An_c',num2str(voi),'(:,6))./sqrt(length(VA_An_c',num2str(voi),'(:,6)));'])
    % Pacific
    eval(['VA_Ps_c',num2str(voi),'=VA_coast_Ps(VA_coast_Ps(:,4)<=bin_zc_bottom(voi) & VA_coast_Ps(:,4)>bin_zc_up(voi),:);'])
    eval(['meanVA_Ps_c(voi)=mean(VA_Ps_c',num2str(voi),'(:,6));'])
    eval(['seVA_Ps_c(voi)=std(VA_Ps_c',num2str(voi),'(:,6))./sqrt(length(VA_Ps_c',num2str(voi),'(:,6)));'])

    eval(['VA_Pn_c',num2str(voi),'=VA_coast_Pn(VA_coast_Pn(:,4)<=bin_zc_bottom(voi) & VA_coast_Pn(:,4)>bin_zc_up(voi),:);'])
    eval(['meanVA_Pn_c(voi)=mean(VA_Pn_c',num2str(voi),'(:,6));'])
    eval(['seVA_Pn_c(voi)=std(VA_Pn_c',num2str(voi),'(:,6))./sqrt(length(VA_Pn_c',num2str(voi),'(:,6)));'])
    % Indian
    eval(['VA_I_c',num2str(voi),'=VA_coast_I(VA_coast_I(:,4)<=bin_zc_bottom(voi) & VA_coast_I(:,4)>bin_zc_up(voi),:);'])
    eval(['meanVA_I_c(voi)=mean(VA_I_c',num2str(voi),'(:,6));'])
    eval(['seVA_I_c(voi)=std(VA_I_c',num2str(voi),'(:,6))./sqrt(length(VA_I_c',num2str(voi),'(:,6)));'])
    % Arctic
    eval(['VA_Ar_c',num2str(voi),'=VA_coast_Ar(VA_coast_Ar(:,4)<=bin_zc_bottom(voi) & VA_coast_Ar(:,4)>bin_zc_up(voi),:);'])
    eval(['meanVA_Ar_c(voi)=mean(VA_Ar_c',num2str(voi),'(:,6));'])
    eval(['seVA_Ar_c(voi)=std(VA_Ar_c',num2str(voi),'(:,6))./sqrt(length(VA_Ar_c',num2str(voi),'(:,6)));'])

    % Mediterranean and Baltic
    eval(['VA_Mnb_c',num2str(voi),'=VA_coast_Mnb(VA_coast_Mnb(:,4)<=bin_zc_bottom(voi) & VA_coast_Mnb(:,4)>bin_zc_up(voi));'])
    eval(['meanVA_Mnb_c(voi)=mean(VA_Mnb_c',num2str(voi),');'])
    eval(['seVA_Mnb_c(voi)=std(VA_Mnb_c',num2str(voi),')./sqrt(length(VA_Mnb_c',num2str(voi),'));'])
end
Total_VAcoastal=nansum(meanVA_As_c.*V_Atlantic_cs*1e6+meanVA_An_c.*V_Atlantic_cn*1e6+meanVA_Ps_c.*V_Pacific_cs*1e6+meanVA_Pn_c.*V_Pacific_cn*1e6+...
    meanVA_I_c.*V_Indian_c*1e6+meanVA_Ar_c.*V_Arctic_c*1e6+meanVA_Mnb_c.*V_Mnb_c*1e6);
total_SEcoatal=nansum(seVA_As_c.*V_Atlantic_cs*1e6+seVA_An_c.*V_Atlantic_cn*1e6+seVA_Ps_c.*V_Pacific_cs*1e6+...
    seVA_Pn_c.*V_Pacific_cn*1e6+seVA_I_c.*V_Indian_c*1e6+seVA_Ar_c.*V_Arctic_c*1e6+seVA_Mnb_c.*V_Mnb_c*1e6);

%% Total viral number in global ocean
Total_VA = Total_VAcoastal+Total_VAopen
Total_SE = total_SEcoatal + total_SEopen